#define QSPV

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <qdos.h>
#include <qptr.h>
#include <stdarg.h>
#include <time.h>
#include <memory.h>
#include <fcntl.h>
#include <unistd.h>

#include <sys/stat.h>

#include "spv.h"
#include "qspv-proto.h"

static long ACTRL (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short bpos, short blen, short, short);
static long AHIT (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short);
static long AEXIT (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);
static long MMOVE (struct WM_wwork *);
static long AICON (struct WM_wwork *, struct WM_litm *);
static long MBARS (struct WM_wwork *, struct WM_litm *);
static long ASLEEP (struct WM_wwork *, struct WM_litm *);

static struct WM_action mbars = {JSR, wm_actli, MBARS};
static struct WM_action afun = {JSR, wm_actli, lit_event};
static struct WM_action asleep = {JSR, wm_actli, ASLEEP};
static struct WM_action aicon = {JSR, wm_actli, AICON};
static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
static struct WM_action actrl = {JSR, wm_ctlaw, ACTRL};

static WM_PWCB (1) xcb = {0};
static WM_PWCB (1) ycb = {0};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork point back to work def */
    NULL,			/* *wdef this was wdef */
    0,				/* chid chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos sub-window and ptr posn */
    0, 0,			/* kstk, kprs key stroke and press */
    0,				/* evnt event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare window mode and spare */
    NULL,			/* *ciact current item "action" */
    -1,				/* citem current item */
    0, 0, 0,			/* cibrw, cipap, cispr current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo current item hit area */
    {0}				/* litem[40] loose item status */
};

#define ninfw    8		/* number of information windows */
#define ninfo    1		/* number of information objects */
#define nlitm    6		/* number of loose items */
#define nappl    1		/* number of application sub-windows */

static QD_TEXTI (END, "ESC");
static QD_TEXTI (VIEW, "slspv");
static QD_TEXTI (MENU, "Menu");

static struct WM_info info1[2] =
{
    {66, 10, 3, 0, 0, 0, 0, 0, 0, &VIEW},
    {-1}
};


static struct WM_infw infw[ninfw + 1] =		/* information window */
{
    {446, 14, 0, 0, 0, 0, 1, 121, NULL},
    {36, 10, 205, 2, 0, 1, 255, 7, info1},
    {442, 14, 2, 15, 0, 1, 255, 7, NULL},
    {26, 10, 6, 17, 0,  1, 255, 7, NULL},
    {400, 10, 40, 17, 0,1, 255, 7, NULL},
    {22, 10, 4, 2, 0, 1, 255, 7, NULL},
    {22, 10, 34, 2, 0, 1, 255, 7, NULL},
/*    {22, 10, 380, 2, 0, 1, 255, 7, NULL}, */
    {22, 10, 410, 2, 0, 1, 255, 7, NULL}, 
    {-1}			/* end of array */
};

extern struct WM_sprite mes_move, mes_size, mes_wake, wm_sprite_sleep,
 mes_null;

static struct WM_litm litm[nlitm + 1] =
{
    {22, 10, 4, 2, 0, 0, 2, K_MOVE, &mes_move, 0, &mmove},
    {22, 10, 34, 2, 0, 0, 2, K_SIZE, &mes_size, 1, &afun},
    {22, 10, 410, 2, 0, 0, 2, K_SLEEP, &wm_sprite_sleep, 2, &asleep},
/*    {22, 10, 380, 2, 0, 0, 2, K_SLEEP, &wm_sprite_sleep, 2, &asleep}, */
/*    {22, 10, 410, 2, 0, 0, 0, K_CANCEL, &END, 3, &aexit}, */
    {26, 10, 6, 17, 0, 0, 0, 0xf0, &MENU, 3, &aicon},	/* F3 */
    {2, 2, 2, 1, 0, 0, 2, 0xfd, &mes_null, 4, &mbars},
    {2, 2, 2, 1, 0, 0, 2, K_TAB, &mes_null, 5, &mbars},
    {-1}
};

static struct WM_menw aw0 =	/* application sub-window */
{
    442, 198,			/* xsize, ysize size */
    2, 31,			/* xorg, yorg and origin */
    0,				/* flag no clear + shadow */
    1, 255, 7,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *pspr pointer to sprite */
    &adraw,			/* *draw draw routine */
    &ahit,			/* *hit hit routine */
    &actrl,			/* *ctrl control routine */
    1, 1,			/* nxsc, nysc max x,y sections */
    0, 0, 0,			/* skey, 2 spare selection keystroke */
    (WM_pwcb_t *) & xcb,	/* *pwcb part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    4, 4, 0,			/* psac, psbc, pssc arrow/bar clrs */
    (WM_pwcb_t *) & ycb,	/* *pwcb part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    4, 4, 0,			/* psac, psbc, pssc arrow/bar clrs */
    {0}
};

static struct WM_appl appl[nappl + 1] = {(WM_appw_t *) & aw0, NULL};

static WM_WSCALE (ninfw + ninfo + nlitm + nappl) wsc =
{
    274, 136, 0, 0, 8, 12,
    {
        {8, 0, 0, 0},           /* infw[0], x scale */
	{0, 0, 4, 0},		/* infw[1], centre */
	{0, 0, 0, 0},  	        /* info[0], no scale */
	{8, 0, 0, 0},		/* infw[2], x scale */
	{0, 0, 0, 0},		/* infw[3], x scale */
	{8, 0, 0, 0},		/* infw[4], x scale */
	{0, 0, 0, 0},		/* infw[5], no scale */
	{0, 0, 0, 0},		/* infw[6], no scale */
	{0, 0, 8, 0},		/* infw[8], right jst */
	{0, 0, 0, 0},		/* litm[0], no scale */
	{0, 0, 0, 0},		/* litm[1], no scale */
	{0, 0, 8, 0},		/* litm[2], right jst */
	{0, 0, 0, 0},		/* litm[4], left jst */
	{0, 0, 0, 0},		/* litm[5], no scale */
	{0, 0, 0, 0},		/* litm[6], no scale */
	{8, 8, 0, 0}		/* appl[0], full scale */
    }
};

static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat pointer to status area */
    (WM_wscale_t *) & wsc,	/* *wscale this was pointer to WDEF */
    0,				/* chid channel ID */
    NULL,			/* *pprec pointer to pointer record */
    0,				/* psave pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst pointer to sprite list */
    446, 232,			/* xsize, ysize size */
    20, 20,			/* xorg, yorg and origin */
    NO_WCLEAR | 0x2,		/* flag no clear + shadow */
    0, 7, 255,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *sprite pointer to sprite */
    1, 0,			/* curw, curc current item width/clr */
    7, 2, NULL, NULL,		/* uback, uink, *ublob, *upatt unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt avail */
    7, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm loose items */
    nappl, appl			/* nappl  *pappl appl winds */
};


long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
int (*_conread) (struct UFB *,void *,unsigned int) = NULL;
int (*_conwrite) (struct UFB *,void *,unsigned int) = NULL;
char *_endmsg = NULL;

long _stack = 10000;

struct WM_wwork *QFVww = &ww;	/* Global ref */

char _prog_name[] = "slspv";
char _version[] = "0.02";

extern setptr (int, int, short *, short *, int);
extern short ScrollIt (short);
extern short PanIt (short);
extern jcall (void (*)(), char *, int, int, int,...);
extern struct WM_wsiz *GetLimits (struct WM_wwork *);
extern int exists (char *);

static PICVIEW vp = {0};
static PICVIEW *pv = &vp;
static short Wdef[4];
static short lx,ly;

/*extern char notmono;*/


int menu (struct WM_wwork *wwk, char *prompt, LLIST **MList, int icount,
	  int xoff, int yoff, int xsize, int ysize, 
	  struct WM_litm *plitem,
	  int nlitem);

void BuildMenu(PICVIEW *);

void *xmalloc (size_t n)
{
    void *p = malloc(n);
    if(p)
    {
	memset(p, 0, n);
    }
    else exit(0);

    return p;
}
void xfree(void *p)
{
    if(p) free(p);
}

void Report (char *ctl,...)
{
    va_list va;
    char t[80];
    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);
    menu_choice (&ww, t, 1, 0, "OK");
}

void QErr (char *txt, int error)
{
    error = -error;
    if (error < 0 || error > os_nerr)
    {
	error = 0;
    }
    Report ("%s: %s", txt, os_errlist[error]);
}


void SetWinFileParams(WM_wwork_t *wwk, short *pdx, short *pdy, short flag)
{
    if(pv)
    {
	pv->wwid = wwk->xsize - AWXOFF - XBARS;
	pv->whgt = wwk->ysize - AWYOFF - YBARS;
	if(pv->ph)
	{
	    GetLimits(wwk);
	    if(pv->ph->xpix < pv->wwid)
	    {
		if(pdx)
		{
		    *pdx = pv->ph->xpix - pv->wwid;
		}
		pv->wwid = pv->ph->xpix;	
	    }
	    else         /* pic > window */
	    {
		if(pdx)
		{
		    if(pv->ph->xpix < wwk->wscale->xmax - AWXOFF - XBARS)
		    {
			*pdx = pv->ph->xpix - pv->wwid;
			pv->wwid = pv->ph->xpix;
		    }
		    else
		    {
			pv->wwid = wwk->wscale->xmax - AWXOFF - XBARS;
			*pdx = wwk->wscale->xmax - wwk->xsize;
		    }
		}
	    }
	    if(pv->ph->ypix < pv->whgt)
	    {
		if(pdy)
		{
		    *pdy = pv->ph->ypix - pv->whgt;
		}
		pv->whgt = pv->ph->ypix;
	    }
	    else
	    {
		if(pdy)
		{
		    if(pv->ph->ypix < wwk->wscale->ymax - AWYOFF - YBARS)
		    {
			*pdy = pv->ph->ypix - pv->whgt;
			pv->whgt = pv->ph->ypix;
		    }
		    else
		    {
			pv->whgt = wwk->wscale->ymax - AWYOFF - YBARS;
			*pdy = wwk->wscale->ymax - wwk->ysize;
		    }
		}
	    }

	    if(flag)
	    {
		pv->cx = pv->cy = 0;
		pv->xx = pv->yy = -1;
	    }
	    
	    pv->act = 0;
	    pv->ly = (pv->ph->ypix - pv->whgt) > 0 
		? (pv->ph->ypix - pv->whgt) : 0;
	    pv->lx = (pv->ph->xpix - pv->wwid) > 0 
		? (pv->ph->xpix - pv->wwid) : 0;
	    pv->mx = ((pv->wwid * 8 /10) + 7) & ~7;
	    pv->my = ((pv->whgt * 8 /10) + 7) & ~7;	
	}
	Wdef[0] = pv->wwid;
	Wdef[1] = pv->whgt;
	Wdef[2] = Wdef[3] = 0;
    }
}

int LoadFile(void)
{
    chanid_t ch;
    int rn = -1;
    struct qdirect qd;
    
    ch = rn = io_open (pv->FileName, 0);
    if(ch > 0)
    {
	fs_headr(ch, -1, &qd, sizeof(qd));
	if(pv->picbuf)
	{
	    free(pv->picbuf);
	}
	
	pv->picbuf = xmalloc(4+qd.d_length);
	if(pv->picbuf)
	{	    
	    pv->ph = (PICHEAD *)((char *)pv->picbuf + 4);
	    rn = fs_load(ch, (void *)pv->ph, qd.d_length);
	    if(rn >= 0 && 
	       ((pv->ph->flag != 0x4afc) || ((pv->ph->mode & 0x0a0a) != 0)))
	    {
		rn = -16;
		pv->imgsz = 0;
	    }
	    else
	    {
		LLIST *pl;
		rn = 0;
		pv->imgsz = qd.d_length;
		for(pl = pv->pX; pl; pl = pl->next)
		{
		    ((MDEF *)pl->item)->status = WSI_AVBL;
		}
	    }
	}
	else
	{
	    pv->ph = NULL;
	    rn = -3;
	}
	io_close(ch);
    }
    return rn;
}

void Checkxstt (short pos)
{
    aw0.xpwcb->s[0].stt = pos;
    if (aw0.xpwcb->s[0].stt > aw0.ncol - aw0.xpwcb->s[0].siz)
    {
	aw0.xpwcb->s[0].stt = aw0.ncol - aw0.xpwcb->s[0].siz;
    }
    if (aw0.xpwcb->s[0].stt < 0)
    {
	aw0.xpwcb->s[0].stt = 0;
    }
}

void Checkystt (short pos)
{
    aw0.ypwcb->s[0].stt = pos;
    if (aw0.ypwcb->s[0].stt > aw0.nrow - aw0.ypwcb->s[0].siz)
    {
	aw0.ypwcb->s[0].stt = aw0.nrow - aw0.ypwcb->s[0].siz;
    }
    if (aw0.ypwcb->s[0].stt < 0)
    {
	aw0.ypwcb->s[0].stt = 0;
    }
}

short ShowPic (PICVIEW *ppv, WM_wsiz_t *wdef)
{
    short res = 0;
    
    switch(ppv->act)
    {
      case 0xd9:                    /* A-DOWN */
	ppv->cy = ppv->cy + ppv->my;
	break;
      case 0xd8:                    /* DOWN */
      case 0xdc:
	ppv->cy = ppv->cy + ppv->my/8;
	break;
      case 0xd1:                    /* A-UP */
	ppv->cy = ppv->cy - ppv->my;
	break;
      case 0xd0:                    /* UP */
      case 0xd4:
	ppv->cy = ppv->cy - ppv->my/8;
	break;
      case 0xc9:                    /* A-RIGHT */
	ppv->cx = ppv->cx + ppv->mx;
	break;
      case 0xc8:                    /* RIGHT */
      case 0xcc:
	ppv->cx = ppv->cx + ppv->mx/8;
	break;
      case 0xc1:                    /* A-LEFT */
	ppv->cx = ppv->cx - ppv->mx;
	break;
      case 0xc0:                    /* LEFT */
      case 0xc4:
	ppv->cx = ppv->cx - ppv->mx/8;
	break;
    }	    
    if(ppv->cx < 0) ppv->cx = 0;
    if(ppv->cx > ppv->lx) ppv->cx = ppv->lx;
    if(ppv->cy < 0) ppv->cy = 0;
    if(ppv->cy > ppv->ly) ppv->cy = ppv->ly;

    if(ppv->cx != ppv->xx || ppv->cy != ppv->yy)
    {
	Checkxstt(ppv->cx);
	Checkystt(ppv->cy);

	res = iop_rspw(ppv->chan, -1, wdef, 
		 ppv->cx, ppv->cy, 1, ppv->picbuf);
#if 0
	Report("%d %d %d %d %d %d %d", res,
	       ppv->cx, ppv->cy, wdef->xsize, wdef->ysize,
	       wdef->xorg, wdef->yorg);
#endif
	ppv->xx = ppv->cx;
	ppv->yy = ppv->cy;
	res = 1;
    }
    return res;
}


static void Showbar (struct WM_wwork *wwk, int val, int lim)
{
    int nlen;
    int wlen;
    QLRECT_t r;
    nlen = infw[4].xsize;
    wlen = val*nlen/lim;
    r.q_width = wlen;
    r.q_height = infw[4].ysize;
    r.q_x = r.q_y = 0;
    wm_swinf (wwk, 4, 0);
    sd_fill(wwk->chid, -1, 2, &r);
}

static void ShowStatus (struct WM_wwork *wwk, short flag, char *ctl,...)
{
    short nlen;

    va_list va;
    char t[80];

    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);

    nlen = infw[4].xsize / 6;
    if (nlen >= 80)
    {
	nlen = 79;
    }
    t[nlen] = 0;
    wm_swinf (wwk, 4, 0);
    if(flag)
    {
	sd_clear (wwk->chid, -1);
    }
    sd_pos(wwk->chid, -1, 0, 0);
    io_sstrg (wwk->chid, -1, t, (short) strlen (t));
}

void ShowBanner  (struct WM_wwork *wwk, short flag)
{
    char *systyp;
    char buf[80];
    
    systyp = (strncmp (_sys_var, "S2AT", 4)) ? "QDOS" : "SMS2";
    sprintf(buf, " %s Pic Viewer (c) Jonathan Hudson 1995-7", systyp);
    if(infw[4].xsize < 37*6)
    {
	buf[17] = 0;
    }
    else if(infw[4].xsize < 41*6)
    {
	buf[37] = 0;
    }
    ShowStatus (wwk, flag, buf);
}

void Doze (short flag)
{
    aw0.xsize = ww.xsize - AWXOFF;
    aw0.ysize = ww.ysize - AWYOFF;
    menu_button (&ww, "qspv", flag);
}

static void ResetAll (struct WM_wwork *wwk, short flag)
{

    ShowBanner (wwk, 1);

    if(flag)
    {
	aw0.ypwcb->s[0].pos = 0;
	aw0.ypwcb->s[0].siz = aw0.ysize;
	aw0.nrow = (pv->ph) ? pv->ph->ypix : aw0.ysize;
	aw0.xpwcb->s[0].pos = 0;
	aw0.xpwcb->s[0].siz = aw0.xsize;
	aw0.ncol = (pv->ph) ? pv->ph->xpix : aw0.xsize;
    }
    wm_index (wwk, (struct WM_swdef *) &aw0);
}


static short DoFileMenu (struct WM_wwork *wwk)
{
    int rn;
    short req = 0;
    static char tail[40] = {0};

    strcat(tail, "_pic");

    if(GetMenuFile("qspv", tail, pv->FileName) == 0)
    {  
	short dx = 0,dy = 0;
	if((rn = LoadFile ()) == 0)
	{
	    SetWinFileParams(wwk, &dx, &dy, 1);
	    if (dx || dy)
	    {
		aw0.xsize = ww.xsize - AWXOFF;
		aw0.ysize = ww.ysize - AWYOFF;
		re_scale (wwk, &dx, &dy);
		re_draw (wwk, dx, dy);
	    }
	    req = 3;
	}
	else
	{
	    sd_clear(pv->chan, -1);
	    QErr("Load File", rn);
	}
    }
    return req;
}

static long MESC (struct WM_wwork *wwk, struct WM_litm *li);
static struct WM_action mesc = {JSR, wm_actli, MESC};
static QD_TEXTI (ESCAPE, "Esc");
#define RETITM 39

static struct WM_litm DD_litm[] =
{
    {24, 10, 100, 2, 0, 0, TYP_TEXT, 3, &ESCAPE, 0, &mesc}, 
    {-1, -1}
};

static long MESC (struct WM_wwork *wwk, struct WM_litm *li)
{
    wwk->wstat->litem[RETITM] = -1;
    lit_reset (wwk, li->item);
    return PT__CAN;             /* and return CAN event */
}

extern char * mygetcwd(char * nambuf, int len);
static short DoTheMenu(struct WM_wwork *wwk)
{
    int n;
    short rv = 0;
    n = menu (wwk, "Menu", &pv->pX, pv->nmenu, 20, 45, 
	      pv->mwidth, 0, DD_litm, 1);
    if(n == 0)
    {
	rv = DoFileMenu(wwk);
    }
    else if (n == pv->nmenu-1)
    {
	exit(0);
    }
    else
    {
	char nam[40] = {0};
	static char tail[40] = {0};
	char *p;
	LLIST *pl;

	if(*tail == 0)
	{
	    mygetcwd(tail, 39);
	}

	for(pl = pv->pX; pl; pl = pl->next, n--)
	{
	    if(n == 0) break;
	}
	if(pl)
	{
	    char cmd[64];
	    int j,k,l;
	    p = tail + strlen(tail);
	    *p++ = '_';
	    strncpy(p, 
		    (char *)((MDEF *)pl->item)->qtext->chrs+8,
		    ((MDEF *)pl->item)->qtext->len - 8);
	    *(p + ((MDEF *)pl->item)->qtext->len - 8) = 0;

	    if((p = strchr(tail, ' ')))
	    {
		*p = 0;
	    }
	    strlwr(tail);
	    strcpy(nam, tail);
	    if(GetMenuFile("qspv", tail, nam) == 0)
	    {
		cmd[0] = pl->extra[0];
		cmd[1] = pl->extra[1];
		strcpy(cmd+2, nam);
		strcat(cmd+2, "\n");
		io_sstrg(pv->cho, -1, cmd, 3+strlen(nam));
		p = (char *)pv->ph;
		l = 0;
		j = pv->imgsz;
		ShowStatus(wwk, 1, "");
		while(j > 0)
		{
		    k = (j > 512) ? 512 : j;
		    l += k;
		    Showbar(wwk, l, pv->imgsz);
		    io_sstrg(pv->cho, -1, p, k);
		    j -= k;
		    p += k;
		}
		ShowBanner (wwk, 1);
	    }
	}
    }
    return rv;
	    
}
static void TheAction (struct WM_wwork *wwk)
{
    short req = 0;
    short x, y;
    int key = 0;
    
    switch(pv->act)
    {
      case 'F':
	  req = DoTheMenu(wwk);
	  break;

	case 'G':
	case 'T':
	case 't':
	    if (pv->act == 'G')
	    {
		x = lx;
		y = ly;
		key = 0;
	    }
	    else
	    {
		short tmp;

		if (pv->act == 'T')
		{
		    x = aw0.xsize + XBARS / 2;
		    tmp = (aw0.ypwcb->s[0].siz > aw0.nrow) ? aw0.nrow : 
			aw0.ypwcb->s[0].siz;
		    y = ((int) ((aw0.ypwcb->s[0].stt + tmp / 2) * aw0.ysize))
			/ aw0.nrow;
		}
		else
		{
		    y = aw0.ysize + YBARS / 2;
		    tmp = (aw0.xpwcb->s[0].siz > aw0.ncol) ? aw0.ncol : 
			aw0.xpwcb->s[0].siz;
		    x = ((int) ((aw0.xpwcb->s[0].stt + tmp / 2) * aw0.xsize))
			/ aw0.ncol;
		}
		key = -1;
	    }
	    setptr (pv->chan, -1, &x, &y, key);
	    break;
	default:
	    if(pv->act > 0xbf)
	    {
		req = 2;
	    }
	    break;
    }

    if (req)
    {
	short res;
	
	if(req & 1)
	{
	    ResetAll(wwk, 1);
	}
	res = ShowPic(pv, (WM_wsiz_t *) Wdef);
	if(res && (req & 2))
	{
	    wm_upbar (wwk, (struct WM_swdef *) &aw0, 0, 0);
	}
    }
}

extern char *_sys_var;

static char *CheckArg (char ***pav, int *pac)
{
    char *p;
    char **av;

    av = *pav;

    if (*++(*av))
    {
	p = *av;
    }
    else if (*(av + 1) && **(av + 1) != '-')
    {
	p = *++av;
	*pac = *pac - 1;
    }
    else
    {
	p = NULL;
    }
    *pav = av;
    return p;
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    exit (0);
}

/* 
 * Draw action routine
 * n.b. makes room for scroll bars (8 pixels)
 */

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    aw0.xsize = wwk->xsize - AWXOFF - XBARS;
    aw0.ysize = wwk->ysize - AWYOFF - YBARS;

    if(pv->ph && (aw0.xsize > pv->ph->xpix))
    {
	Wdef[2] = (aw0.xsize - pv->ph->xpix)/2;
	Wdef[0] =  pv->ph->xpix;
    }
    else
    {
	Wdef[0] = aw0.xsize;
	Wdef[2] = 0;
    }
    
    if(pv->ph && (aw0.ysize > pv->ph->ypix))
    {
	Wdef[3] = (aw0.ysize - pv->ph->ypix)/2;	    
	Wdef[1] =  pv->ph->ypix;
    }
    else
    {
	Wdef[1] = aw0.ysize;
	Wdef[3] = 0;
    }
    
    wm_swdef (wwk, apw, pv->chan);

    ResetAll (wwk, 1);

    if (pv->ph && pv->ph->xpix)
    {
	pv->xx = -1;
	if(ShowPic (pv, (WM_wsiz_t *) Wdef))
	{
	    wm_upbar (wwk, (struct WM_swdef *) &aw0, 0, 0);
	}
    }
    return 0;
}

/* 
 * Hit routine, calculate displacement (iline) and set a DO event
 * (From a keystroke in window event)
 */

static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw,
		  struct WM_wstat *wst, short x, short y, short evnt)
{
    static short lx=0, ly=0, lk = 0;

    if(((evnt & 0xc0) == 0xc0) && (evnt & 0x5))
    {
	lk = 0;
	pv->act = evnt;
	wst->evnt |= PT_DO;
    }
    else if(wst->evnt & PT_KEYUP)
    {
	lk = 0;
    } 
    else if((wst->evnt & PT_KYSTK) && ((evnt == K_HIT) || (evnt == K_DO)))
    {
	lk = evnt;
	lx = x;
	ly = y;
    }
    else if((wst->evnt & PT_KYPRS) && lk)
    {
	if(lx != x || ly != y)
	{
	    short xmov, ymov;
	    xmov = x - lx;
	    ymov = y - ly;
	    if(lk == K_DO)
	    {
		short mlt;
		if(xmov)
		{
		    mlt = 1+ (pv->ph->xpix/aw0.xsize);
		    xmov *= mlt;
		}
		if(ymov)
		{
		    mlt = 1+ (pv->ph->ypix/aw0.ysize);
		    ymov *= mlt;
		}
	    }
	    
	    pv->cx += xmov;
	    pv->cy += ymov;
	    ly = y;
	    lx = x;
	    pv->act = 0xff;
	    wst->evnt |= PT_DO;
	}
    }
    return AHIT_NORMAL;
}

static long AICON (struct WM_wwork *wwk, struct WM_litm *li)
{
    pv->act = 'F';
    lit_reset (wwk, li->item);
    return PT__DO;
}
static long MMOVE (struct WM_wwork *wwk)
{
    short dx, dy;
    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */
    wm_swdef (wwk, (struct WM_appw *) &aw0, pv->chan);
    return lit_reset (wwk, 0);	/* and return */
}

static long ACTRL (struct WM_wwork *wwk, struct WM_appw *apw, struct WM_wstat *wst, short bpos, short blen, short item, short evnt)
{
    if ((evnt & 0xf) == 0xa)
    {
	pv->cx = aw0.ncol * bpos / blen;
	Checkxstt (pv->cx);
	pv->act = 0xff;
    }
    else
    {
	pv->cy = aw0.nrow * bpos / blen;
	Checkystt (pv->cy);
	pv->act = 0xff;
    }
    return PT__DO;
}

static long ASLEEP (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    return PT__ZZZZ;
}
static long MBARS (struct WM_wwork *wwk, struct WM_litm *li)
{
    short ix, iy, inx, iny;

    ix = wwk->xorg + wwk->xsize - wwk->wstat->ptpsx;
    iy = wwk->yorg + wwk->ysize - wwk->wstat->ptpsy;

    inx = (ix >= 0 && ix < XBARS);
    iny = (iy >= 0 && iy < YBARS);

    if (li->item == 5)
    {
	if (inx)
	{
	    pv->act = 'G';
	}
	else
	{
	    if (!iny)
	    {
		lx = wwk->wstat->ptpsx;
		ly = wwk->wstat->ptpsy;
	    }
	    pv->act = 'T';
	}
    }
    else
    {
	if (iny)
	{
	    pv->act = 'G';
	}
	else
	{
	    if (!inx)
	    {
		lx = wwk->wstat->ptpsx;
		ly = wwk->wstat->ptpsy;
	    }
	    pv->act = 't';
	}
    }
    return PT__DO;
}

int main (int ac, char **av)
{
    int c;
    short i, dx = 0, dy = 0, lfl = 0;
    short atp = 0;
    struct WM_wsiz *wl;
    LLIST *pX = NULL;

    if (ac > 1)
    {
	strcpy (pv->FileName, *(av+1));
	lfl = 1;
    }
    
    ww.chid = fgetchid (stdout);

    if (ww.chid < 0)
    {
	return -1;
    }

    if (!(wm_findv (ww.chid)))
    {
	return -1;
    }

    wl = GetLimits (&ww);
    pv->chan = io_open ("scr", 0);
    ws.wwork = &ww;		/* set cross reference */

    aw0.ypwcb->nsec = 1;
    aw0.xpwcb->nsec = 1;

    BuildMenu(pv);

    if (lfl)
    {
	if(LoadFile () == 0)
	{
	    SetWinFileParams(&ww, &dx, &dy, 1);
	}
    }

    if (dx || dy)
    {
	re_scale (&ww, &dx, &dy);
    }
#if 0
    if (notmono)
#endif
    {
	infw[0].papr = 84;
    }

    if (atp)
    {
	dx = dy = -1;
    }
    else
    {
	dx = (wl->xsize - ww.xsize) / 2;
	dy = (wl->ysize - ww.ysize) / 2;
    }

    wm_prpos (&ww, dx, dy);
    wm_wdraw (&ww);

    lx = ww.wstat->ptpsx;
    ly = ww.wstat->ptpsy;

    while (1)
    {
	wm_rptr (&ww);

	if (ws.evnt & PT_ZZZZ)
	{
	    pv->xx += 8;
	    Doze (1);
	}

	if (ws.evnt & PT_WSIZE)
	{
	    aw0.xsize = ww.xsize - AWXOFF;
	    aw0.ysize = ww.ysize - AWYOFF;
	    /*
	     * If we don't do a resize, we MUST restore the correct APW
	     * size or its BLACK Hole time again.....
	     */
	    if (re_size (&ww, 1) == 0)
	    {
		aw0.xsize = ww.xsize - AWXOFF - XBARS;
		aw0.ysize = ww.ysize - AWYOFF - YBARS;
	    }
	    pv->act = 0;
	}

	if ((ws.evnt & PT_DO) && pv->act)
	{
	    TheAction (&ww);
	    pv->act = 0;
	}
    }

    io_close (pv->chan);
    wm_cluns (&ww);
    return (0);
}
